Subject: Re: [PATCH]: net/bonding: Enable to change device type before enslaving

From: Moni Shoua <[email-masked]>
Date: Sun, 13 Apr 2008 17:09:20 +0300

> 	Does this mean that the automatic selection on first enslavement
> is no longer needed, and all setting of the type for IB devices must
> occur prior to first enslavement?
> 
> 	Or is this more of a special case for some devices, and the
> automatic selection is still correct for most cases?
> 

I think that the later is closer to the truth. 
The goal is to modify the bonding module to work with IPoIB slaves but
with as small as possible changes to what already exists.

In details, the bonding net device device gets its type by ether_setup(),
which runs for all types of slaves and I don't see a way to change that.
However, bonding master for IPoIB slaves requires a different device type setting 
before it comes up for some OSs (redhat 4 for instance). On other OSs I don't see the problem 
and I guess that this is because master becomes up only after it has slaves.